DescriptorProtos.FileOptionsOrBuilder
Date: 2017-07-08

com.google.protobuf

## Interface DescriptorProtos.FileOptionsOrBuilder

- All Superinterfaces:
    GeneratedMessageV3.ExtendableMessageOrBuilder<DescriptorProtos.FileOptions>, MessageLiteOrBuilder, MessageOrBuilder
  All Known Implementing Classes:
    DescriptorProtos.FileOptions, DescriptorProtos.FileOptions.Builder
  Enclosing class:
    DescriptorProtos

      public static interface DescriptorProtos.FileOptionsOrBuilder
      extends GeneratedMessageV3.ExtendableMessageOrBuilder<DescriptorProtos.FileOptions>

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `getCcEnableArenas()` Enables the use of arenas for the proto messages in this file.
    `boolean` | `getCcGenericServices()` Should generic services be generated in each language? "Generic" services are not specific to any particular RPC system.
    `java.lang.String` | `getCsharpNamespace()` Namespace for generated classes; defaults to the package.
    `ByteString` | `getCsharpNamespaceBytes()` Namespace for generated classes; defaults to the package.
    `boolean` | `getDeprecated()` Is this file deprecated? Depending on the target platform, this can emit Deprecated annotations for everything in the file, or it will be completely ignored; in the very least, this is a formalization for deprecating files.
    `java.lang.String` | `getGoPackage()` Sets the Go package where structs generated from this .proto will be placed.
    `ByteString` | `getGoPackageBytes()` Sets the Go package where structs generated from this .proto will be placed.
    `boolean` | `getJavaGenerateEqualsAndHash()` Deprecated.
    `boolean` | `getJavaGenericServices()` `optional bool java_generic_services = 17 [default = false];`
    `boolean` | `getJavaMultipleFiles()` If set true, then the Java code generator will generate a separate .java file for each top-level message, enum, and service defined in the .proto file.
    `java.lang.String` | `getJavaOuterClassname()` If set, all the classes from the .proto file are wrapped in a single outer class with the given name.
    `ByteString` | `getJavaOuterClassnameBytes()` If set, all the classes from the .proto file are wrapped in a single outer class with the given name.
    `java.lang.String` | `getJavaPackage()` Sets the Java package where classes generated from this .proto will be placed.
    `ByteString` | `getJavaPackageBytes()` Sets the Java package where classes generated from this .proto will be placed.
    `boolean` | `getJavaStringCheckUtf8()` If set true, then the Java2 code generator will generate code that throws an exception whenever an attempt is made to assign a non-UTF-8 byte sequence to a string field.
    `java.lang.String` | `getObjcClassPrefix()` Sets the objective c class prefix which is prepended to all objective c generated classes from this .proto.
    `ByteString` | `getObjcClassPrefixBytes()` Sets the objective c class prefix which is prepended to all objective c generated classes from this .proto.
    `DescriptorProtos.FileOptions.OptimizeMode` | `getOptimizeFor()` `optional .google.protobuf.FileOptions.OptimizeMode optimize_for = 9 [default = SPEED];`
    `java.lang.String` | `getPhpClassPrefix()` Sets the php class prefix which is prepended to all php generated classes from this .proto.
    `ByteString` | `getPhpClassPrefixBytes()` Sets the php class prefix which is prepended to all php generated classes from this .proto.
    `boolean` | `getPyGenericServices()` `optional bool py_generic_services = 18 [default = false];`
    `java.lang.String` | `getSwiftPrefix()` By default Swift generators will take the proto package and CamelCase it replacing '.' with underscore and use that to prefix the types/symbols defined.
    `ByteString` | `getSwiftPrefixBytes()` By default Swift generators will take the proto package and CamelCase it replacing '.' with underscore and use that to prefix the types/symbols defined.
    `DescriptorProtos.UninterpretedOption` | `getUninterpretedOption(int index)` The parser stores options it doesn't recognize here.
    `int` | `getUninterpretedOptionCount()` The parser stores options it doesn't recognize here.
    `java.util.List<DescriptorProtos.UninterpretedOption>` | `getUninterpretedOptionList()` The parser stores options it doesn't recognize here.
    `DescriptorProtos.UninterpretedOptionOrBuilder` | `getUninterpretedOptionOrBuilder(int index)` The parser stores options it doesn't recognize here.
    `java.util.List<? extends DescriptorProtos.UninterpretedOptionOrBuilder>` | `getUninterpretedOptionOrBuilderList()` The parser stores options it doesn't recognize here.
    `boolean` | `hasCcEnableArenas()` Enables the use of arenas for the proto messages in this file.
    `boolean` | `hasCcGenericServices()` Should generic services be generated in each language? "Generic" services are not specific to any particular RPC system.
    `boolean` | `hasCsharpNamespace()` Namespace for generated classes; defaults to the package.
    `boolean` | `hasDeprecated()` Is this file deprecated? Depending on the target platform, this can emit Deprecated annotations for everything in the file, or it will be completely ignored; in the very least, this is a formalization for deprecating files.
    `boolean` | `hasGoPackage()` Sets the Go package where structs generated from this .proto will be placed.
    `boolean` | `hasJavaGenerateEqualsAndHash()` Deprecated.
    `boolean` | `hasJavaGenericServices()` `optional bool java_generic_services = 17 [default = false];`
    `boolean` | `hasJavaMultipleFiles()` If set true, then the Java code generator will generate a separate .java file for each top-level message, enum, and service defined in the .proto file.
    `boolean` | `hasJavaOuterClassname()` If set, all the classes from the .proto file are wrapped in a single outer class with the given name.
    `boolean` | `hasJavaPackage()` Sets the Java package where classes generated from this .proto will be placed.
    `boolean` | `hasJavaStringCheckUtf8()` If set true, then the Java2 code generator will generate code that throws an exception whenever an attempt is made to assign a non-UTF-8 byte sequence to a string field.
    `boolean` | `hasObjcClassPrefix()` Sets the objective c class prefix which is prepended to all objective c generated classes from this .proto.
    `boolean` | `hasOptimizeFor()` `optional .google.protobuf.FileOptions.OptimizeMode optimize_for = 9 [default = SPEED];`
    `boolean` | `hasPhpClassPrefix()` Sets the php class prefix which is prepended to all php generated classes from this .proto.
    `boolean` | `hasPyGenericServices()` `optional bool py_generic_services = 18 [default = false];`
    `boolean` | `hasSwiftPrefix()` By default Swift generators will take the proto package and CamelCase it replacing '.' with underscore and use that to prefix the types/symbols defined.

    - ### Methods inherited from interface com.google.protobuf.GeneratedMessageV3.ExtendableMessageOrBuilder

      `getDefaultInstanceForType, getExtension, getExtension, getExtension, getExtension, getExtension, getExtension, getExtensionCount, getExtensionCount, getExtensionCount, hasExtension, hasExtension, hasExtension`

    - ### Methods inherited from interface com.google.protobuf.MessageOrBuilder

      `findInitializationErrors, getAllFields, getDescriptorForType, getField, getInitializationErrorString, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, getUnknownFields, hasField, hasOneof`

    - ### Methods inherited from interface com.google.protobuf.MessageLiteOrBuilder

      `isInitialized`

- - ### Method Detail

    - #### hasJavaPackage

          boolean hasJavaPackage()

           Sets the Java package where classes generated from this .proto will be
           placed.  By default, the proto package is used, but this is often
           inappropriate because proto packages do not normally start with backwards
           domain names.

      `optional string java_package = 1;`

    - #### getJavaPackage

          java.lang.String getJavaPackage()

           Sets the Java package where classes generated from this .proto will be
           placed.  By default, the proto package is used, but this is often
           inappropriate because proto packages do not normally start with backwards
           domain names.

      `optional string java_package = 1;`

    - #### getJavaPackageBytes

          ByteString getJavaPackageBytes()

           Sets the Java package where classes generated from this .proto will be
           placed.  By default, the proto package is used, but this is often
           inappropriate because proto packages do not normally start with backwards
           domain names.

      `optional string java_package = 1;`

    - #### hasJavaOuterClassname

          boolean hasJavaOuterClassname()

           If set, all the classes from the .proto file are wrapped in a single
           outer class with the given name.  This applies to both Proto1
           (equivalent to the old "--one_java_file" option) and Proto2 (where
           a .proto always translates to a single class, but you may want to
           explicitly choose the class name).

      `optional string java_outer_classname = 8;`

    - #### getJavaOuterClassname

          java.lang.String getJavaOuterClassname()

           If set, all the classes from the .proto file are wrapped in a single
           outer class with the given name.  This applies to both Proto1
           (equivalent to the old "--one_java_file" option) and Proto2 (where
           a .proto always translates to a single class, but you may want to
           explicitly choose the class name).

      `optional string java_outer_classname = 8;`

    - #### getJavaOuterClassnameBytes

          ByteString getJavaOuterClassnameBytes()

           If set, all the classes from the .proto file are wrapped in a single
           outer class with the given name.  This applies to both Proto1
           (equivalent to the old "--one_java_file" option) and Proto2 (where
           a .proto always translates to a single class, but you may want to
           explicitly choose the class name).

      `optional string java_outer_classname = 8;`

    - #### hasJavaMultipleFiles

          boolean hasJavaMultipleFiles()

           If set true, then the Java code generator will generate a separate .java
           file for each top-level message, enum, and service defined in the .proto
           file.  Thus, these types will *not* be nested inside the outer class
           named by java_outer_classname.  However, the outer class will still be
           generated to contain the file's getDescriptor() method as well as any
           top-level extensions defined in the file.

      `optional bool java_multiple_files = 10 [default = false];`

    - #### getJavaMultipleFiles

          boolean getJavaMultipleFiles()

           If set true, then the Java code generator will generate a separate .java
           file for each top-level message, enum, and service defined in the .proto
           file.  Thus, these types will *not* be nested inside the outer class
           named by java_outer_classname.  However, the outer class will still be
           generated to contain the file's getDescriptor() method as well as any
           top-level extensions defined in the file.

      `optional bool java_multiple_files = 10 [default = false];`

    - #### hasJavaGenerateEqualsAndHash

          @Deprecated
          boolean hasJavaGenerateEqualsAndHash()

      Deprecated.

           This option does nothing.

      `optional bool java_generate_equals_and_hash = 20 [deprecated = true];`

    - #### getJavaGenerateEqualsAndHash

          @Deprecated
          boolean getJavaGenerateEqualsAndHash()

      Deprecated.

           This option does nothing.

      `optional bool java_generate_equals_and_hash = 20 [deprecated = true];`

    - #### hasJavaStringCheckUtf8

          boolean hasJavaStringCheckUtf8()

           If set true, then the Java2 code generator will generate code that
           throws an exception whenever an attempt is made to assign a non-UTF-8
           byte sequence to a string field.
           Message reflection will do the same.
           However, an extension field still accepts non-UTF-8 byte sequences.
           This option has no effect on when used with the lite runtime.

      `optional bool java_string_check_utf8 = 27 [default = false];`

    - #### getJavaStringCheckUtf8

          boolean getJavaStringCheckUtf8()

           If set true, then the Java2 code generator will generate code that
           throws an exception whenever an attempt is made to assign a non-UTF-8
           byte sequence to a string field.
           Message reflection will do the same.
           However, an extension field still accepts non-UTF-8 byte sequences.
           This option has no effect on when used with the lite runtime.

      `optional bool java_string_check_utf8 = 27 [default = false];`

    - #### hasOptimizeFor

          boolean hasOptimizeFor()

      `optional .google.protobuf.FileOptions.OptimizeMode optimize_for = 9 [default = SPEED];`

    - #### getOptimizeFor

          DescriptorProtos.FileOptions.OptimizeMode getOptimizeFor()

      `optional .google.protobuf.FileOptions.OptimizeMode optimize_for = 9 [default = SPEED];`

    - #### hasGoPackage

          boolean hasGoPackage()

           Sets the Go package where structs generated from this .proto will be
           placed. If omitted, the Go package will be derived from the following:
             - The basename of the package import path, if provided.
             - Otherwise, the package statement in the .proto file, if present.
             - Otherwise, the basename of the .proto file, without extension.

      `optional string go_package = 11;`

    - #### getGoPackage

          java.lang.String getGoPackage()

           Sets the Go package where structs generated from this .proto will be
           placed. If omitted, the Go package will be derived from the following:
             - The basename of the package import path, if provided.
             - Otherwise, the package statement in the .proto file, if present.
             - Otherwise, the basename of the .proto file, without extension.

      `optional string go_package = 11;`

    - #### getGoPackageBytes

          ByteString getGoPackageBytes()

           Sets the Go package where structs generated from this .proto will be
           placed. If omitted, the Go package will be derived from the following:
             - The basename of the package import path, if provided.
             - Otherwise, the package statement in the .proto file, if present.
             - Otherwise, the basename of the .proto file, without extension.

      `optional string go_package = 11;`

    - #### hasCcGenericServices

          boolean hasCcGenericServices()

           Should generic services be generated in each language?  "Generic" services
           are not specific to any particular RPC system.  They are generated by the
           main code generators in each language (without additional plugins).
           Generic services were the only kind of service generation supported by
           early versions of google.protobuf.
           Generic services are now considered deprecated in favor of using plugins
           that generate code specific to your particular RPC system.  Therefore,
           these default to false.  Old code which depends on generic services should
           explicitly set them to true.

      `optional bool cc_generic_services = 16 [default = false];`

    - #### getCcGenericServices

          boolean getCcGenericServices()

           Should generic services be generated in each language?  "Generic" services
           are not specific to any particular RPC system.  They are generated by the
           main code generators in each language (without additional plugins).
           Generic services were the only kind of service generation supported by
           early versions of google.protobuf.
           Generic services are now considered deprecated in favor of using plugins
           that generate code specific to your particular RPC system.  Therefore,
           these default to false.  Old code which depends on generic services should
           explicitly set them to true.

      `optional bool cc_generic_services = 16 [default = false];`

    - #### hasJavaGenericServices

          boolean hasJavaGenericServices()

      `optional bool java_generic_services = 17 [default = false];`

    - #### getJavaGenericServices

          boolean getJavaGenericServices()

      `optional bool java_generic_services = 17 [default = false];`

    - #### hasPyGenericServices

          boolean hasPyGenericServices()

      `optional bool py_generic_services = 18 [default = false];`

    - #### getPyGenericServices

          boolean getPyGenericServices()

      `optional bool py_generic_services = 18 [default = false];`

    - #### hasDeprecated

          boolean hasDeprecated()

           Is this file deprecated?
           Depending on the target platform, this can emit Deprecated annotations
           for everything in the file, or it will be completely ignored; in the very
           least, this is a formalization for deprecating files.

      `optional bool deprecated = 23 [default = false];`

    - #### getDeprecated

          boolean getDeprecated()

           Is this file deprecated?
           Depending on the target platform, this can emit Deprecated annotations
           for everything in the file, or it will be completely ignored; in the very
           least, this is a formalization for deprecating files.

      `optional bool deprecated = 23 [default = false];`

    - #### hasCcEnableArenas

          boolean hasCcEnableArenas()

           Enables the use of arenas for the proto messages in this file. This applies
           only to generated classes for C++.

      `optional bool cc_enable_arenas = 31 [default = false];`

    - #### getCcEnableArenas

          boolean getCcEnableArenas()

           Enables the use of arenas for the proto messages in this file. This applies
           only to generated classes for C++.

      `optional bool cc_enable_arenas = 31 [default = false];`

    - #### hasObjcClassPrefix

          boolean hasObjcClassPrefix()

           Sets the objective c class prefix which is prepended to all objective c
           generated classes from this .proto. There is no default.

      `optional string objc_class_prefix = 36;`

    - #### getObjcClassPrefix

          java.lang.String getObjcClassPrefix()

           Sets the objective c class prefix which is prepended to all objective c
           generated classes from this .proto. There is no default.

      `optional string objc_class_prefix = 36;`

    - #### getObjcClassPrefixBytes

          ByteString getObjcClassPrefixBytes()

           Sets the objective c class prefix which is prepended to all objective c
           generated classes from this .proto. There is no default.

      `optional string objc_class_prefix = 36;`

    - #### hasCsharpNamespace

          boolean hasCsharpNamespace()

           Namespace for generated classes; defaults to the package.

      `optional string csharp_namespace = 37;`

    - #### getCsharpNamespace

          java.lang.String getCsharpNamespace()

           Namespace for generated classes; defaults to the package.

      `optional string csharp_namespace = 37;`

    - #### getCsharpNamespaceBytes

          ByteString getCsharpNamespaceBytes()

           Namespace for generated classes; defaults to the package.

      `optional string csharp_namespace = 37;`

    - #### hasSwiftPrefix

          boolean hasSwiftPrefix()

           By default Swift generators will take the proto package and CamelCase it
           replacing '.' with underscore and use that to prefix the types/symbols
           defined. When this options is provided, they will use this value instead
           to prefix the types/symbols defined.

      `optional string swift_prefix = 39;`

    - #### getSwiftPrefix

          java.lang.String getSwiftPrefix()

           By default Swift generators will take the proto package and CamelCase it
           replacing '.' with underscore and use that to prefix the types/symbols
           defined. When this options is provided, they will use this value instead
           to prefix the types/symbols defined.

      `optional string swift_prefix = 39;`

    - #### getSwiftPrefixBytes

          ByteString getSwiftPrefixBytes()

           By default Swift generators will take the proto package and CamelCase it
           replacing '.' with underscore and use that to prefix the types/symbols
           defined. When this options is provided, they will use this value instead
           to prefix the types/symbols defined.

      `optional string swift_prefix = 39;`

    - #### hasPhpClassPrefix

          boolean hasPhpClassPrefix()

           Sets the php class prefix which is prepended to all php generated classes
           from this .proto. Default is empty.

      `optional string php_class_prefix = 40;`

    - #### getPhpClassPrefix

          java.lang.String getPhpClassPrefix()

           Sets the php class prefix which is prepended to all php generated classes
           from this .proto. Default is empty.

      `optional string php_class_prefix = 40;`

    - #### getPhpClassPrefixBytes

          ByteString getPhpClassPrefixBytes()

           Sets the php class prefix which is prepended to all php generated classes
           from this .proto. Default is empty.

      `optional string php_class_prefix = 40;`

    - #### getUninterpretedOptionList

          java.util.List<DescriptorProtos.UninterpretedOption> getUninterpretedOptionList()

           The parser stores options it doesn't recognize here. See above.

      `repeated .google.protobuf.UninterpretedOption uninterpreted_option = 999;`

    - #### getUninterpretedOption

          DescriptorProtos.UninterpretedOption getUninterpretedOption(int index)

           The parser stores options it doesn't recognize here. See above.

      `repeated .google.protobuf.UninterpretedOption uninterpreted_option = 999;`

    - #### getUninterpretedOptionCount

          int getUninterpretedOptionCount()

           The parser stores options it doesn't recognize here. See above.

      `repeated .google.protobuf.UninterpretedOption uninterpreted_option = 999;`

    - #### getUninterpretedOptionOrBuilderList

          java.util.List<? extends DescriptorProtos.UninterpretedOptionOrBuilder> getUninterpretedOptionOrBuilderList()

           The parser stores options it doesn't recognize here. See above.

      `repeated .google.protobuf.UninterpretedOption uninterpreted_option = 999;`

    - #### getUninterpretedOptionOrBuilder

          DescriptorProtos.UninterpretedOptionOrBuilder getUninterpretedOptionOrBuilder(int index)

           The parser stores options it doesn't recognize here. See above.

      `repeated .google.protobuf.UninterpretedOption uninterpreted_option = 999;`